Package: config
Type: Package
Title: Manage Environment Specific Configuration Values
Version: 0.3
Authors@R: c(
  person("JJ", "Allaire", role = c("aut", "cre"), email = "jj@rstudio.com"),
  person(family = "RStudio, Inc.", role = "cph"))
Imports: yaml (>= 2.1.13)
Suggests: testthat, knitr
Description: Manage configuration values across multiple environments (e.g.
  development, test, production). Read values using a function that determines
  the current environment and returns the appropriate value.
License: GPL-3
URL: https://github.com/rstudio/config
BugReports: https://github.com/rstudio/config/issues
RoxygenNote: 6.0.1
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2018-03-27 17:50:45 UTC; jjallaire
Author: JJ Allaire [aut, cre],
  RStudio, Inc. [cph]
Maintainer: JJ Allaire <jj@rstudio.com>
Repository: CRAN
Date/Publication: 2018-03-27 20:38:53 UTC
Built: R 3.4.1; ; 2018-09-09 23:04:32 UTC; windows

## ----setup, include=FALSE-----------------------------------------------------
# knitr::opts_chunk$set(eval = TRUE, results = 'hide')
Sys.setenv(R_CONFIG_ACTIVE = "default")

## ---- include=FALSE-----------------------------------------------------------
knitr::knit_engines$set(yaml = function(options) {
  code <- paste(options$code, collapse = "\n")
  options$results <- "hide"
  varname <- options$output.var
  if (!is.null(varname)) {
    assign(varname, code, envir = knitr::knit_global())
  }
  knitr::engine_output(options, code, out = code)
}
                          )

set_codeblock_label <- function(x) {
  sprintf("<p class = 'codeblock-label'>%s</p>", x)
}

knitr::knit_hooks$set(codeblock_label = function(before, options, name) {
  if (before) {
    if (is.character(options[[name]])) {
      set_codeblock_label(options[[name]])
    } else if (options$engine == "yaml") {
      set_codeblock_label("config.yml")
    } else {
      set_codeblock_label(options$engine)
    }
  }
})

knitr::knit_hooks$set(with_config = local({
  old_envvars <- NA
  function(before, options) {
    if (before) {
      config_yml <- base::get(options$config_yml, envir = knitr::knit_global())
      .config_file <- config:::write_yaml_as_file(config_yml)
      new_envvars <- .config_file
      old_envvars <<- config:::keep_old_envvars(new_envvars)
      config:::set_new_envvars(new_envvars)
    } else {
      config:::reset_envvars(old_envvars)
    }
  }
}))

knitr::opts_chunk$set(
  codeblock_label = TRUE
)

## ---- with_config=TRUE, config_yml="config_yaml"------------------------------
config <- config::get()
config$trials
config$dataset

## ---- with_config=TRUE, config_yml="config_yaml"------------------------------
config::get("trials")
config::get("dataset")

## ---- with_config=TRUE, config_yml="config_yaml"------------------------------
# set the active configuration globally via Renviron.site or Rprofile.site
Sys.setenv(R_CONFIG_ACTIVE = "production")

# read configuration value (will return 30 from the "production" config)
config::get("trials")

## ---- with_config=TRUE, config_yml="config_yaml"------------------------------
config::is_active("production")

## -----------------------------------------------------------------------------
Sys.setenv(R_CONFIG_ACTIVE = "default")

## ---- eval=FALSE--------------------------------------------------------------
#  config <- config::get(file = "conf/config.yml")

## ---- eval=FALSE--------------------------------------------------------------
#  config <- config::get(file = "conf/config.yml", use_parent = FALSE)

yaml <- '
default:
  db_name: dbase
  databases:
    db1: !expr paste0(db_name, "/one")
    db2: !expr paste0(db_name, "/two")

staging:
  staging_postfix: _staging
  db_name: dbase
  databases:
    db1: !expr paste0(db_name, staging_postfix, "/one")
    db2: !expr paste0(db_name, staging_postfix, "/two")
'

# Ensure that base::get() doesn't get masked, for tests on CRAN
get <- base::get

with_config(yaml, config::get() )
with_config(yaml, config::get("databases", config = "default") )
with_config(yaml, config::get("databases", config = "staging") )

config_file <- system.file("tests/testthat/config.yml", package = "config")
if (file.exists(config_file)) {
  with_config(config_file, config::get())
}

test_that("configurations inherit from default", {
  conf <- config::get(config = "development")
  expect_identical(conf$color, "red")
  expect_identical(conf$shape, "triangle")
})

test_that("configurations can inherit from other configurations", {
  conf <- config::get(config = "test")
  expect_identical(conf$shape, "triangle")
})

test_that("configuration inheriting from itself is an error", {
  expect_error(config::get(config = "test", file = "config-inheritself.yml"),
               regexp = "inherits from itself")
})

test_that("configurations can inherit from multiple other configurations", {
  config <- config::get(config = "west", file = "config-multiple.yml")
  expect_identical(config$shape, "hexagon")
  expect_identical(config$log, TRUE)
})

test_that("with_config leaves env vars intact", {
  yaml <- '
  default:
    key: value
    eval_1: !expr Sys.getenv("extra_1")
    eval_2: !expr Sys.getenv("extra_2")
  prod:
    key: prod_value
  '
  old_envs <- Sys.getenv()
  expect_equal(old_envs, Sys.getenv())

  expect_equal(
    with_config(yaml, config::get("key")),
    "value"
  )

  # test different specifications of .active_config
  expect_equal(
    with_config(yaml, config::get("key"), .active_config = "default"),
    "value"
  )

  expect_equal(
    with_config(yaml, config::get("key"), .active_config = "prod"),
    "prod_value"
  )

  expect_equal(
    with_config(yaml, config::get("eval_1"), .extra_env_vars = c(extra_1 = "extra_value")),
    "extra_value"
  )

  expect_equal(
    with_config(yaml, config::get("eval_2"),
                .extra_env_vars = c(c(extra_1 = "extra_value"), c(extra_2 = "extra_value_2"))
                ),
    "extra_value_2"
  )

  expect_equal(old_envs, Sys.getenv())

  config::get("color", config = "assigned") %>%
    expect_identical("black")
})

test_that("with_config() handles R object", {

  yaml_object <- list(
    default = list(
      key = "value"
    ),
    prod = list(
      key = "prod_value"
    )
  )

  expect_equal(
    with_config(yaml_object, config::get("key")),
    "value"
  )

  expect_equal(
    with_config(yaml_object, config::get("key"), .active_config = "prod"),
    "prod_value"
  )

})

test_that("configuration file can be loaded", {
  config::get() %>%
    expect_type("list")
})

test_that("default configuration can be read", {
  color <- config::get("color")
  expect_identical(color, "red")
  shape <- config::get("shape")
  expect_identical(shape, "square")
})

test_that("configuration can be accessed as a list", {
  conf <- config::get()
  expect_identical(conf$color, "red")
  expect_identical(conf$shape, "square")
})

test_that("configurations override default", {
  conf <- config::get(config = "production")
  expect_identical(conf$color, "green")
  expect_identical(conf$shape, "circle")
})

test_that("configuration can be read from alternate file", {
  expect_identical(config::get("color", file = "config/conf.yml"), "red")
})

test_that("active configuration can be changed via an environment variable", {
  # restore previous state of environment after test
  previous_config <- Sys.getenv("R_CONFIG_ACTIVE", unset = NA);
  on.exit({
    if (!is.na(previous_config))
      Sys.setenv(R_CONFIG_ACTIVE = previous_config)
    else
      Sys.unsetenv("R_CONFIG_ACTIVE")
  }, add = TRUE)

  Sys.setenv(R_CONFIG_ACTIVE = "production")
  expect_identical(config::get("shape"), "circle")
})

test_that("R code is executed when reading configurations", {
  expect_identical(config::get("color", config = "dynamic"), "orange")
  #expect_error(config::get("color", config = "error"))
})

test_that("expressions are evaluated recursively", {
  expect_identical(
    config::get("nested", config = "dynamic"),
    list(shape = "circle", taste = "sweet")
  )
})

library(testthat)
test_that("expressions can use previously assigned parameters", {
  config::get("color", config = "assigned") %>%
    expect_identical("black")

  config::get("color_shape", config = "assigned") %>%
    expect_identical("black dotted")

  config::get("nested", config = "assigned") %>%
    .$nested_color_shape %>%
    expect_equal("black dotted")
})

test_that("expressions can use previously assigned parameters", {
  config::get("color", config = "assigned_error") %>%
    expect_error(".*Attempt to assign nested list value from expression..*")

  config::get("new_nested_not_found", config = "assigned_error") %>%
    expect_error(".*Attempt to assign nested list value from expression..*")
})

test_that("config file is discovered in parent directory", {
  expect_identical(config::get("color", file = "parent/child/config.yml"),
                   "red")
})

test_that("use_parent prevents scanning of parent directories", {
  expect_error(config::get("color",
                           file = "parent/child/config.yml",
                           use_parent = FALSE),
               regexp = "not found in current working")

})

test_that("search for config file properly terminates", {
  expect_error(config::get("color", file = "parent/child/notexists.yml"),
               regexp = "not found in current working")
})

test_that("search for config file works without directory", {
  old <- setwd("parent")
  on.exit(setwd(old))
  expect_identical(config::get("color", file = "config-multiple.yml"),
                   "red")
})

---
title: "config package for R"
output: 
  rmarkdown::html_vignette:
    readme: true
vignette: >
  %\VignetteIndexEntry{config package for R}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(eval = FALSE, results = 'hide')
Sys.setenv(R_CONFIG_ACTIVE = "default")
```

The **config** package makes it easy to manage environment specific configuration values. For example, you might want to use distinct values for development, testing, and production environments.

You can install the **config** package from CRAN as follows:

```{r}
install.packages("config")
```

## Usage

Configurations are defined using a [YAML](http://www.yaml.org/about.html) text file and are read by default from a file named **config.yml** in the current working directory (or parent directories if no config file is found in the initially specified directory).

Configuration files include default values as well as values for arbitrary other named configurations, for example:

**config.yml**

```yaml
default:
  trials: 5
  dataset: "data-sampled.csv"
  
production:
  trials: 30
  dataset: "data.csv"
```

To read configuration values you call the `config::get` function, which returns a list containing all of the values for the currently active configuration:

```{r}
config <- config::get()
config$trials
config$dataset
```

You can also read a single value from the configuration as follows:

```{r}
config::get("trials")
config::get("dataset")
```

The `get` function takes an optional `config` argument which determines which configuration to read values from (the "default" configuration is used if none is specified). 

## Configurations

You can specify which configuration is currently active by setting the `R_CONFIG_ACTIVE` environment variable. The `R_CONFIG_ACTIVE` variable is typically set within a site-wide `Renviron` or `Rprofile` (see [R Startup](https://stat.ethz.ch/R-manual/R-devel/library/base/html/Startup.html) for details on these files).

```{r}
# set the active configuration globally via Renviron.site or Rprofile.site
Sys.setenv(R_CONFIG_ACTIVE = "production")

# read configuration value (will return 30 from the "production" config)
config::get("trials")
```

You can check whether a particular configuration is active using the `config::is_active` function:

```{r}
config::is_active("production")
```

```{r, include=FALSE}
Sys.setenv(R_CONFIG_ACTIVE = "default")
```

## Defaults and Inheritance

The `default` configuration provides a set of values to use when no named configuration is active. Other configurations automatically inherit all `default` values so need only define values specialized for that configuration. For example, in this configuration the `production` configuration doesn't specify a value for `trials` so it will be read from the `default` configuration:

**config.yml**

```yaml
default:
  trials: 5
  dataset: "data-sampled.csv"
  
production:
  dataset: "data.csv"
```

All configurations automatically inherit from the "default" configuration. Configurations can also inherit from one or more other named configurations. For example, in this file the `production` configuration inherits from the `test` configuration:

**config.yml**

```yaml
default:
  trials: 5
  dataset: "data-sampled.csv"

test:
  trials: 30
  dataset: "data-test.csv"
  
production:
  inherits: test
  dataset: "data.csv"
```

## Configuration Files

By default configuration data is read from a file named **config.yml** within the current working directory (or parent directories if no config file is found in the initially specified directory). 

You can use the `file` argument of `config::get` to read from an alternate location. For example:

```{r, eval=FALSE}
config <- config::get(file = "conf/config.yml")
```

If you don't want to ever scan parent directories for configuration files then you can specify `use_parent = FALSE`:

```{r, eval=FALSE}
config <- config::get(file = "conf/config.yml", use_parent = FALSE)
```

## R Code 

You can execute R code within configuration files by prefacing values with `!expr`. This could be useful in the case where you want to base configuration values on environment variables, R options, or even other config files. For example:

```yaml
default:
  cores: 2
  debug: true
  server: "localhost:5555"
   
production:
  cores: !expr getOption("mc.cores")
  debug: !expr Sys.getenv("ENABLE_DEBUG") == "1"
  server: !expr config::get("server", file = "/etc/server-config.yml")
```

---
title: "Getting started with the config package"
output:
  rmarkdown::html_vignette:
    css:
    - !expr system.file("rmarkdown/templates/html_vignette/resources/vignette.css", package = "rmarkdown")
    - ../man/fragments/codeblock.css
vignette: >
  %\VignetteIndexEntry{Getting started with the config package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
# knitr::opts_chunk$set(eval = TRUE, results = 'hide')
Sys.setenv(R_CONFIG_ACTIVE = "default")
```

```{r child="../man/fragments/knitr_with_config_hooks.Rmd", include = FALSE}
```

## Overview

The `config` package makes it easy to manage environment specific configuration values. For example, you might want to use distinct values for development, testing, and production environments.


## Usage

Configurations are defined using a [YAML](https://yaml.org/about.html) text file and are read by default from a file named **config.yml** in the current working directory (or parent directories if no config file is found in the initially specified directory).

Configuration files include default values as well as values for arbitrary other named configurations, for example:


```{yaml output.var="config_yaml"}
default:
  trials: 5
  dataset: "data-sampled.csv"
  
production:
  trials: 30
  dataset: "data.csv"
```

To read configuration values you call the `config::get` function, which returns a list containing all of the values for the currently active configuration:

```{r, with_config=TRUE, config_yml="config_yaml"}
config <- config::get()
config$trials
config$dataset
```

You can also read a single value from the configuration as follows:

```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("trials")
config::get("dataset")
```

The `get` function takes an optional `config` argument which determines which configuration to read values from (the "default" configuration is used if none is specified). 

## Configurations

You can specify which configuration is currently active by setting the `R_CONFIG_ACTIVE` environment variable. The `R_CONFIG_ACTIVE` variable is typically set within a site-wide `Renviron` or `Rprofile` (see [R Startup](https://stat.ethz.ch/R-manual/R-devel/library/base/html/Startup.html) for details on these files).

```{r, with_config=TRUE, config_yml="config_yaml"}
# set the active configuration globally via Renviron.site or Rprofile.site
Sys.setenv(R_CONFIG_ACTIVE = "production")

# read configuration value (will return 30 from the "production" config)
config::get("trials")
```

You can check whether a particular configuration is active using the `config::is_active` function:

```{r, with_config=TRUE, config_yml="config_yaml"}
config::is_active("production")
```

```{r}
Sys.setenv(R_CONFIG_ACTIVE = "default")
```

## Configuration Files

By default configuration data is read from a file named **config.yml** within the current working directory (or parent directories if no config file is found in the initially specified directory). 

You can use the `file` argument of `config::get` to read from an alternate location. For example:

```{r, eval=FALSE}
config <- config::get(file = "conf/config.yml")
```

If you don't want to ever scan parent directories for configuration files then you can specify `use_parent = FALSE`:

```{r, eval=FALSE}
config <- config::get(file = "conf/config.yml", use_parent = FALSE)
```




```{r child="../man/fragments/no_attach.Rmd"}
```

---
title: "Using config with Posit Connect"
output:
  rmarkdown::html_vignette:
    css:
    - !expr system.file("rmarkdown/templates/html_vignette/resources/vignette.css", package = "rmarkdown")
    - ../man/fragments/codeblock.css
vignette: >
  %\VignetteIndexEntry{Using config with Posit Connect}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r child="../man/fragments/knitr_with_config_hooks.Rmd", include = FALSE}
```

The purpose of the `config` package is to respond to environment variables that could be set to different values on different machines. Specifically, config reacts to the value of `R_CONFIG_ACTIVE`, and this allows you to set configurations for different machines, e.g. in dev or production.

If you deploy your code to a Posit Connect instance, then you can use the fact that Connect sets the value of `R_CONFIG_ACTIVE` to `rsconnect`.

This means you can create a configuration file using the value `rsconnect`, for example:


```{yaml}
default:
  trials: 5
  dataset: "data-sampled.csv"
  
rsconnect:
  trials: 30
  dataset: "data.csv"
```

Note: this value can be configured by your system administrator, so check your own system configuration!  See <https://docs.posit.co/connect/admin/appendix/configuration/#R.ConfigActive> for detail.

## Using config for staging and prod on multiple servers

Many customers of Posit Connect will have separate Connect instances for the purposes of separating staging and production.

In this case, the system administrator needs to configure the `R_CONFIG_ACTIVE` environment variable to have different values on each machine. For example:

- On the staging server: `rsconnect-staging`
- On the production server: `rsconnect-prod`

Using these example values, you could configure the `config.yml` file to look like this:


```{yaml output.var="config_yaml"}
default:
  trials: 5
  dataset: "data-sampled.csv"

rsconnect:
  trials: 30
  
rsconnect-staging:
  inherits: rsconnect
  dataset: "data-staging.csv"
  
rsconnect-prod:
  inherits: rsconnect
  dataset: "data.csv"
```

Note that this configuration uses the inheritance of `config` yaml files, by having a common configuration for `rsconnect` and staging and prod configurations that inherit from the `rsconnect` configuration.




## Using config for staging and prod on a single server

You may have the use case that you use the same Connect instance to host two instances of your app, for staging (test) and production.

In this use case you will soon run into the problem that an individual user can not change the the environment variable `R_CONFIG_ACTIVE`, since this is configured system-wide by the administrator.

But you can still use `config` to set different values for staging and prod, by changing the environment variable that `config::get()` looks at.


Specifically, you must specify a different `config` argument to `config::get()`.  For example, you can create a new environment variable for your Connect app, called `R_CONFIG_ACTIVE_APP`, and then use `config::get()` like this:

```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("trials", config = Sys.getenv("R_CONFIG_ACTIVE_APP"))
```

Again, this example utilizes the inheritance of `config` yaml files, by having a common configuration for `rsconnect` and staging and prod configurations that inherit from the `rsconnect` configuration.

In such a case, you may have a `config.yml` file like this:



```{yaml output.var="config_yaml"}
default:
  trials: 5
  dataset: "data-sampled.csv"

rsconnect:
  trials: 30
  
staging:
  inherits: rsconnect
  dataset: "data-staging.csv"
  
prod:
  inherits: rsconnect
  dataset: "data.csv"
```


If you configure the environment variable correctly, you should get the appropriate `dataset` values for staging (`data-staging.csv`) and prod (`data.csv`):

```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("dataset", config = "staging")
config::get("dataset", config = "prod")
```

## A utility function that might be helpful

If you are in the situation where you wish to use a different environment variable, you can potentially save a few keystrokes by defining a utility function that wraps around `config::get()`.  Such a utility simply passes a different value for the `config` argument, like this:

```r
cfg_get_app <- function (
  value = NULL, 
  config = Sys.getenv("R_CONFIG_ACTIVE_APP", "default"), 
  ...
) {
  config::get(value = value, config = config, ...)
}
```

You can then call this function from your app:

``` R
cfg_get_app("value")
```

---
title: "Inheritance and R expressions"
output:
  rmarkdown::html_vignette:
    css:
    - !expr system.file("rmarkdown/templates/html_vignette/resources/vignette.css", package = "rmarkdown")
    - ../man/fragments/codeblock.css
vignette: >
  %\VignetteIndexEntry{Inheritance and R expressions}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```


```{r child="../man/fragments/knitr_with_config_hooks.Rmd", include = FALSE}
```

## Defaults and inheritance

The `default` configuration provides a set of values to use when no named configuration is active. Other configurations automatically inherit all `default` values so need only define values specialized for that configuration.

For example, in this configuration the `production` configuration doesn't specify a value for `trials` so it will be read from the `default` configuration:


```{yaml output.var="config_yaml"}
default:
  trials: 5
  dataset: "data-sampled.csv"
  
production:
  dataset: "data.csv"
```



```{r, with_config=TRUE, config_yml="config_yaml"}
config::get(config = "production")
```


All configurations automatically inherit from the `default` configuration. Configurations can also inherit from one or more other named configurations. For example, in this file the `production` configuration inherits from the `test` configuration:


```{yaml, output.var = "config_yaml"}
default:
  trials: 5
  dataset: "data-sampled.csv"

test:
  trials: 30
  dataset: "data-test.csv"
  
production:
  inherits: test
  dataset: "data.csv"
```


```{r, with_config=TRUE, config_yml="config_yaml"}
config::get(config = "production")
```

## Using R code inside the yaml file

You can execute R code within configuration files by prefacing values with `!expr`. This could be useful in cases where you want to base configuration values on environment variables, R options, or even other config files. For example:


```{yaml, output.var = "config_yaml"}
default:
  cores: 2
  debug: true
  server: "localhost:5555"
   
production:
  cores: !expr getOption("mc.cores")
  debug: !expr Sys.getenv("ENABLE_DEBUG") == "1"
  server: !expr config::get("server", file = "etc/server-config.yml")
```


The default result:

```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("server")
```


The production result will depend on the environment variables on the server:


```{r, codeblock_label = "server-config.yml"}
cat(readLines("etc/server-config.yml"), sep = "\n")
```


```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("server", config = "production")
```




### Referencing previously assigned parameters

You can use any previously assigned parameter inside of R code so long as it is assigned directly.


```{yaml, output.var = "config_yaml"}
default:
  file: "data.csv"

test:
  data_dir: "test/out"
  dataset: !expr file.path(data_dir, file)
  
production:
  data_dir: "production/out"
  dataset: !expr file.path(data_dir, file)
```



```{r, with_config=TRUE, config_yml="config_yaml"}
config::get("dataset", config = "test")
```

```{r, with_config=TRUE, config_yml="config_yaml"}
config::get(config = "production")
```


## Limitations of using R expressions

The ability to use R expressions gives substantial flexibility to allow configurations to depend on environment variables, files and other information that's available in the target environment.

However, keep in mind these limitations:

- Any R expression can only refer to elements in the configuration file that it inherits from.
- An R expression can not refer to another R expression.

If the config file violates these limitations, `config::get()` will throw an error.

As an example, let's say you want to construct a configuration that computes a location based on a filename and a folder.

### A valid example

If both `filename` and `folder` are constant (i.e. not computed expressions) this works:


```{yaml, output.var = "config_yaml"}
default:
  filename: "trials.csv"
  folder: "some/path"
  location: !expr file.path(folder, filename)
```


```{r, with_config=TRUE, config_yml="config_yaml", error = TRUE}
config::get("location")
```

### An invalid example

However, if `folder` is also a computed value, then `location` can not be computed and this throws an error:

```{yaml, output.var = "config_yaml"}
default:
  filename: "trials.csv"
  folder: !expr c("some/path")
  location: !expr file.path(folder, filename)
```


```{r, with_config=TRUE, config_yml="config_yaml", error = TRUE}
config::get("location")
```
